<script setup lang="ts">
import { Form, FormSchema } from '../../../../components/Form'
import { useForm } from '../../../../hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { DepartmentUserItem } from '../../../../api/system-config/department/types'
import { useValidator } from '../../../../hooks/web/useValidator'

const { required, phone, email, idCard } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<DepartmentUserItem>,
    default: () => undefined
  },
  formSchema: {
    type: Array as PropType<FormSchema[]>,
    default: () => []
  },
  disabled: {
    type: Boolean,
    default: false
  }
})

const rules = reactive({
  userName: [required()],
  userNo: [required()],
  deptIds: [{ ...required(), trigger: 'change' }],
  idCard: [idCard()],
  email: [required(), email()],
  phone: [required(), phone()]
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :disabled="disabled" :schema="formSchema" />
</template>
